//+------------------------------------------------------------------+
//|                                      _KG_BB_BS_NGUNDUH_DOLAR.mq4 |
//|                                                            d4y47 |
//|                                      http://www.kgforexworld.com |
//+------------------------------------------------------------------+
#property copyright "d4y47"
#property link      "http://www.kgforexworld.com"

#property indicator_chart_window
#property indicator_buffers 7

extern	string	Readme1			= "#--- Periode Huruf/Angka",
						Readme2			= "4H 8H 1D 1W 1MH 4MH 1Y 4Y",
						Periode			= "1D";
extern	int		LabelDistance	= 30;
extern	int		MidWidth			= 2,
						BBWidth			= 1,
						BSHLWidth		= 1;
extern	color		MidColor			= 0,
						BBColor			= DarkSlateGray;
extern   bool 		ShowID 			= false,
						ShowPrice 		= false;

int		CBar,Per,IndexShift,TMP_IndexShift,PerPengarah,PerLSMA;

double	BSBand_BS[],
			SMA_BB_UP_01[],SMA_BB_UP_02[],SMA_BB_UP_03[],
			SMA_BB_DOWN_01[],SMA_BB_DOWN_02[],SMA_BB_DOWN_03[],Pengarah[],LSMA[];

bool		ERROR = false;

color		WarnaMid,WarnaBSHL,WarnaPengarah;

string	NamaLabel;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
	IndicatorBuffers(7);
	if(GlobalVariableCheck("CBar"))
		CBar = GlobalVariableGet("CBar");
	else	
		GlobalVariableSet("CBar",0);

	if(Periode == "4Y" || Periode == "4y")				{ Periode = "4Y";		WarnaMid	= Coral;		WarnaPengarah	= RosyBrown; WarnaBSHL = WarnaMid;	Per = MathCeil((345600*4)/Period()); PerPengarah=MathCeil(345600/Period());}
	else if(Periode == "1Y" || Periode == "1y")		{ Periode = "1Y";		WarnaMid	= RosyBrown; WarnaPengarah	= SandyBrown;		WarnaBSHL = WarnaMid;	Per = MathCeil(345600/Period()); PerPengarah=MathCeil(115200/Period());}
	else if(Periode == "4MH"	|| Periode == "4mh")	{ Periode = "4MH";	WarnaMid	= SandyBrown; WarnaPengarah	= Aqua;				WarnaBSHL = WarnaMid;	Per = MathCeil(115200/Period()); PerPengarah=MathCeil(28800/Period());}
	else if(Periode == "1MH"	|| Periode == "1mh")	{ Periode = "1MH";	WarnaMid	= Aqua; WarnaPengarah	= Magenta;				WarnaBSHL = WarnaMid;	Per = MathCeil(28800/Period()); PerPengarah=MathCeil(7200/Period());}
	else if(Periode == "1W"		|| Periode == "1w")	{ Periode = "1W";		WarnaMid	= Magenta; WarnaPengarah	= Lime;			WarnaBSHL = WarnaMid;	Per = MathCeil(7200/Period()); PerPengarah=MathCeil(1440/Period());}
	else if(Periode == "1D"		|| Periode == "1d")	{ Periode = "1D";		WarnaMid	= Lime; WarnaPengarah	= Yellow;				WarnaBSHL = WarnaMid;	Per = MathCeil(1440/Period()); PerPengarah=MathCeil(480/Period());}
	else if(Periode == "8H"		|| Periode == "8h")	{ Periode = "8H";		WarnaMid	= Yellow; WarnaPengarah	= Blue;			WarnaBSHL = WarnaMid;	Per = MathCeil(480/Period()); PerPengarah=MathCeil(240/Period());}
	else if(Periode == "4H"		|| Periode == "4h")	{ Periode = "4H";		WarnaMid	= Blue; WarnaPengarah	= Red;				WarnaBSHL = WarnaMid;	Per = MathCeil(240/Period()); PerPengarah=MathCeil(60/Period());}
	else{
     	if(IsDigit(Periode)){
         WarnaMid		= White;
			WarnaBSHL	= WarnaMid;
			Per			= StrToInteger(Periode);
			PerPengarah = Per/2;
		}
		else{
			Alert("Periode tidak ditemukan!");
			ERROR = true;
			return(0);
		}
	}

	if(MidColor != 0)
		WarnaMid		= MidColor;
	if(BBColor != 0)
		WarnaBSHL	= BBColor;


	SetIndexBuffer(0,BSBand_BS);
	SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, MidWidth , WarnaMid);
	SetIndexLabel(0,"BS "+Periode);	

	SetIndexBuffer(1,Pengarah);
	SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, MidWidth , WarnaPengarah);
	SetIndexLabel(1,"Pengarah "+Periode);	

	   SetIndexStyle(2, DRAW_LINE, STYLE_DOT, BBWidth, BBColor);
   	SetIndexBuffer(2, SMA_BB_UP_01);
  	 	SetIndexLabel(2, "SMA "+Periode+" SD +1");

	   SetIndexStyle(3, DRAW_LINE, STYLE_DOT, BBWidth, BBColor);
		SetIndexBuffer(3, SMA_BB_DOWN_01);
   	SetIndexLabel(3, "SMA "+Periode+" SD -1");

   	SetIndexStyle(4, DRAW_LINE, STYLE_DOT, BBWidth, BBColor);
   	SetIndexBuffer(4, SMA_BB_UP_02);
   	SetIndexLabel(4, "SMA "+Periode+" SD +2");

   	SetIndexStyle(5, DRAW_LINE, STYLE_DOT, BBWidth, BBColor);
   	SetIndexBuffer(5, SMA_BB_DOWN_02);
   	SetIndexLabel(5, "SMA "+Periode+" SD -2");

   if(Periode=="1D"){
   PerLSMA = MathCeil(600/Period());
	SetIndexBuffer(6,LSMA);
	SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, MidWidth , White);
	SetIndexLabel(6,"LSMA "+Periode);	
   }
	NamaLabel	= "KGBSBAND"+Periode;
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
	int i,obj_total;
	string name;
	obj_total=ObjectsTotal();
	for(i=obj_total;i>=0;i--){
		name	= ObjectName(i);
		if(StringFind(name, NamaLabel, 0) != -1)
			ObjectDelete(name);
	}   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
	if((Per <= 0) || ERROR){
		return(0);
	}
	
	int		counted_bars	= IndicatorCounted(),
   			i,limit;
	string 	Legend,Sign;
	
	double	HI,LOW,BUYER,SELLER,BUYERSELLER;

   if (counted_bars < 0)	return(-1);
   if(counted_bars > 0)		counted_bars--;

	limit	= Bars-counted_bars;

	if((CBar!=0) && (limit>=CBar))
		limit=CBar;

	if(limit < IndexShift)
		limit += IndexShift;

	TMP_IndexShift = IndexShift;

   for(i=0; i<limit; i++){
		if(TMP_IndexShift != 0){
   		HI				= High[iHighest(NULL,0, MODE_HIGH, Per-TMP_IndexShift, 0)];
   		LOW			= Low[iLowest(NULL, 0, MODE_LOW, Per-TMP_IndexShift, 0)];
		}
		else{
			HI				= High[iHighest(NULL,0, MODE_HIGH, Per, i-IndexShift)];
   		LOW			= Low[iLowest(NULL, 0, MODE_LOW, Per, i-IndexShift)];
		}

   	BUYERSELLER	= (HI+LOW)/2;
   	BUYER			= (HI+BUYERSELLER)/2;
   	SELLER		= (BUYERSELLER+LOW)/2;

		BSBand_BS[i]= BUYERSELLER;

      SMA_BB_UP_01[i] = iBands(NULL,0,Per,1,0,PRICE_WEIGHTED,MODE_UPPER,i);
      SMA_BB_DOWN_01[i] = iBands(NULL,0,Per,1,0,PRICE_WEIGHTED,MODE_LOWER,i);
      SMA_BB_UP_02[i] = iBands(NULL,0,Per,2,0,PRICE_WEIGHTED,MODE_UPPER,i);
      SMA_BB_DOWN_02[i] = iBands(NULL,0,Per,2,0,PRICE_WEIGHTED,MODE_LOWER,i);
   }// END FOR

   for(i=0; i<limit; i++){
   if(Periode=="1D"){
      Pengarah[i]=iMA(NULL,0,PerPengarah,0,MODE_SMA,PRICE_WEIGHTED,i);
      LSMA[i]   = 3.0*iMA(NULL,0,PerLSMA,0,MODE_LWMA,PRICE_MEDIAN,i)-2.0*iMA(NULL,0,PerLSMA,0,MODE_SMA,PRICE_MEDIAN,i);
   }
   else{
		if(TMP_IndexShift != 0){
   		HI				= High[iHighest(NULL,0, MODE_HIGH, PerPengarah-TMP_IndexShift, 0)];
   		LOW			= Low[iLowest(NULL, 0, MODE_LOW, PerPengarah-TMP_IndexShift, 0)];
		}
		else{
			HI				= High[iHighest(NULL,0, MODE_HIGH, PerPengarah, i-IndexShift)];
   		LOW			= Low[iLowest(NULL, 0, MODE_LOW, PerPengarah, i-IndexShift)];
		}

   	BUYERSELLER	= (HI+LOW)/2;

		Pengarah[i]= BUYERSELLER;
   }   
   }// END FOR

	if(ShowPrice || ShowID){
		SET_LABEL("_BS_", "BS", Time[0]+(Period()*60*LabelDistance), BSBand_BS[IndexShift], WarnaMid);

	}// END IF

}
bool IsDigit(string str){
   bool		result=true;
   string	s=str;
   int lenght=StringLen(str)-1,symbol;

   while(lenght>0){
      symbol=StringGetChar(s,lenght);
      if(!(symbol>47 && symbol<58)){
         result=false;
         break;
      }
      lenght--;
   }
   return(result);
}

void SET_LABEL(string NAMA, string TEXT, datetime WAKTU, double HARGA, color WARNA){

	if(ShowPrice){
		if(ObjectFind(NamaLabel+NAMA) == -1)
			ObjectCreate(NamaLabel+NAMA, OBJ_ARROW, 0, WAKTU, HARGA);

		ObjectSet(NamaLabel+NAMA, OBJPROP_TIME1, WAKTU);
		ObjectSet(NamaLabel+NAMA, OBJPROP_PRICE1, HARGA);
		ObjectSet(NamaLabel+NAMA, OBJPROP_COLOR, WARNA);
		ObjectSet(NamaLabel+NAMA, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
	}

	if(ShowID){
		NAMA = NAMA + " TXT";
   	if(ObjectFind(NamaLabel+NAMA) == -1)
			ObjectCreate(NamaLabel+NAMA, OBJ_TEXT, 0, WAKTU, HARGA);

		ObjectSet(NamaLabel+NAMA, OBJPROP_TIME1, WAKTU);
		ObjectSet(NamaLabel+NAMA, OBJPROP_PRICE1, HARGA);
		ObjectSetText(NamaLabel+NAMA, TEXT, 8, "Verdana", WARNA);
		ObjectSetText(NamaLabel+NAMA, TEXT, 8, "Verdana", WARNA);
	}
}// END SET_LABEL

